//+------------------------------------------------------------------+
//|                                                     StoCycle.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
#property indicator_buffers 3 

#property indicator_color1 Teal
#property indicator_color2 Magenta
#property indicator_color3 DodgerBlue

extern int PeriodLength = 48;
extern bool EnableUpAlert = true;
extern bool EnableDownAlert = true;

double stoch[],top[],bottom[];

#property indicator_separate_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

SetIndexBuffer(0,stoch);
SetIndexBuffer(1,top);
SetIndexBuffer(2,bottom);

SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
SetIndexStyle(1,DRAW_ARROW,EMPTY,1);
SetIndexStyle(2,DRAW_ARROW,EMPTY,1);

SetIndexArrow(1,108);
SetIndexArrow(2,108);

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
int t=0,b=0;
//----

if(PeriodLength==0 || PeriodLength>Bars)
PeriodLength=Bars;

for(int s=PeriodLength;s>=0;s--)stoch[s] = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,s);

for(int i=PeriodLength;i>=0;i--)
{
   if(stoch[i+2]>stoch[i+1] && stoch[i+1]<stoch[i])
   {
      bottom[i+1] = stoch[i+1];
      b++;
   }
   else
   bottom[i+1] = EMPTY_VALUE;
   
   if(stoch[i+2]<stoch[i+1] && stoch[i+1]>stoch[i])
   {
      top[i+1] = stoch[i+1];
      t++;
   }
   else
   top[i+1] = EMPTY_VALUE;
   
      
}   

Comment("LENGTH: ",PeriodLength,"\nTops ",(t),"\nBottoms ",(b),
"\nC Tops ",(PeriodLength/t),"\nC Bottoms ",(PeriodLength/b),"\nAverage ",NormalizeDouble(  ( (PeriodLength/t) + (PeriodLength/b) )/2,2 ));
   
   static datetime dtBarTime = 0;

   if (dtBarTime == Time[0]) return(0);  
   dtBarTime = Time[0];

   if (EnableUpAlert == true){
		if ((bottom[2] != EMPTY_VALUE) && (iOpen(Symbol(),Period(),2) > iClose(Symbol(),Period(),2)) && (iOpen(Symbol(),Period(),1) < iClose(Symbol(),Period(),1))){
			Alert(Symbol()," ",TimeToStr(TimeCurrent()), " Sto Up");

		}
	}
      
	if (EnableDownAlert == true){
		if ((top[2] != EMPTY_VALUE)  && (iOpen(Symbol(),Period(),2) < iClose(Symbol(),Period(),2)) && (iOpen(Symbol(),Period(),1) > iClose(Symbol(),Period(),1))){
			Alert(Symbol()," ",TimeToStr(TimeCurrent()), " Sto Down");
		}
	}

   return(0);
  }
//+------------------------------------------------------------------+